	xdef	_library
	xdef	sndlib@0000
	xdef	sndlib@0001

        include "tios.h"
	xdef _ti89

;*****************************************************

sndlib@0000:			; sndlib::PlaySong
	movem.l		d0-d4/a0-a1,-(a7)
	move.w		#$700,d0
	trap		#1			; Disable interrupts
	move.w		d0,oldsr		; Store old sr
	bset.b		#6,$60000C		; Init full I/O control
	move.l		(a0)+,d3		; Load tempo
reload:
	lea		data(PC),a1		; Load freqtable
	clr.l		d0
	move.b		(a0)+,d0		; Load next note
	cmp.b		#255,d0			; Check if end of song
	beq		sdone1
	cmp.b		#99,d0			; Check for pause
	bne		nopause
	move.b		#72,d0
nopause:
	lsl.l		#1,d0			; Double it since freqs are words
	clr.l		d1
	move.w		0(a1,d0.w),d1		; Get freq
	move.l		d3,d2			; Copy tempo
	clr.l		d4
	move.b		(a0)+,d4
	divu		d4,d2			; d2=length of note
	add.l		#$FFFF,d2
sloop1:
	subq.w		#1,d1
	beq		dosnd1			; Check if we should set wire
	bra		nosnd1			; Obvioulsy not
dosnd1:
	bchg.b		#0,$60000E		; Change wire state
	bchg.b		#1,$60000E		; Change wire state
	move.w		0(a1,d0.w),d1		; Reload freq
nosnd1:
	dbra		d2,sloop1		; Do it for length
	cmp.b		#$FF,$60001B		; Check for keypress
	beq		reload			; If none then continue
sdone1:
	bclr.b 		#0,$60000E		; Set wire low
	bclr.b 		#1,$60000E		; Set wire low
	move.b 		#$8D,$60000C		; Turn off full I/O control
	move.w		oldsr,d0
	trap		#1			; Restore old sr
	movem.l		(a7)+,d0-d4/a0-a1
	rts					; Exit


sndlib@0001:			; sndlib::Beep
	movem.l		d0-d2,-(a7)
	move.l		d0,-(a7)		; Save d0 (freq)
	move.w		#$700,d0
	trap		#1			; Disable interrupts
	move.w		d0,oldsr		; Store old sr
	move.l		(a7)+,d0		; Restore d0
	bset.b		#6,$60000C		; Init full I/O control
	move.l		d0,d2			; Copy freq
sloop2:
	subq.l		#1,d0
	beq		dosnd2			; Check if we should set wires
	bra		nosnd2			; Obviuosly not
dosnd2:
	bchg.b		#0,$60000E		; Change wire state
	bchg.b		#1,$60000E		; Change wire state
	move.l		d2,d0			; Reload freq
nosnd2:
	dbra		d1,sloop2		; Beep for length
sdone2:
	bclr.b 		#0,$60000E		; Set wire low
	bclr.b 		#1,$60000E		; Set wire low
	move.b 		#$8D,$60000C		; Turn off full I/O control
	move.w		oldsr,d0
	trap		#1			; Restore old sr
	movem.l		(a7)+,d0-d2
	rts					; Exit
	rts


;*****************************************************

oldsr	dc.w	0

data:	       ;C    C#  D   D#  E   F   F#  G   G#  A   A#  B
	dc.w   1056,997,941,888,838,791,747,705,665,628,593,559		; 0-11
	dc.w	528,498,470,444,419,396,373,352,333,314,296,280		; 12-23
	dc.w	264,249,235,222,210,198,187,176,166,157,148,140		; 24-35
	dc.w	132,125,118,111,105,099,093,088,083,078,074,070		; 36-47
	dc.w	066,062,059,055,052,049,047,044,042,039,037,035		; 48-59
	dc.w	033,031,030,028,026,025,024,022,021,020,019,018		; 60-71
	dc.w	$FFFF



;*****************************************************

	end
